// dllmain.cpp : Defines the entry point for the DLL application.
#include <temple/taskscheduler/taskscheduler.h>
#include <rbx/memory/functions/functions.h>
#include <rbx/checks/minhook/MinHook.h>
#include <rbx/memory/memdata/memdata.h>
#include <rbx/lua/customfn/customfn.h>
#include <themida/ThemidaSDK.h>
#include <temple/config/config.h>
#include <rbx/memory/memory.h>
#include <rbx/lua/execution.h>
#include <overlay/overlay.h>
#include <util/console.h>
#include <store/store.h>
#include <auth/auth.h>
#include <crypto/crypto.h>
#include <ui/bridge.h>

#include <filesystem>
#include <Windows.h>
#include <xorstr.h>
#include <iostream>
#include <thread>

bool initialise()
{
    //temple::util::console::create();

    //std::cout << "aTHEMIDA\n";

    //std::cout << " -- Welcome to Temple --\n\n";

    //std::cout << " - Preparing bridge...\n\n";

    temple::ui::bridge::initialise_pipe();

    //temple::config::util::current_path = temple::ui::bridge::read_string();
    std::string bin_path = temple::ui::bridge::read_string();

    temple::config::util::current_path = std::filesystem::path(bin_path).parent_path().string();

    //std::cout << " -- Current path: " << temple::config::util::current_path << "\n";

    //std::cout << "\n\n";


    auto r = temple::auth::is_logged_in();
    if (!r.has_value())
    {
        exit(0);
        *reinterpret_cast<std::uintptr_t*>(0) = 0;
        return 0;
    }


    //temple::memory::validate_memory_locations(*r);

    //std::cout << " - Preparing addresses...\n\n";

    temple::memdata::base_addresses();
    temple::functions::ready_functions();

    //std::cout << "\n";

    //std::cout << " - Preparing MinHook...";

    if (MH_Initialize() != MH_OK)
    {
        //std::cout << "Oops, something went wrong!\n";
        return false;
    }
   
    //std::cout << "OK\n\n";
}

void start()
{
    initialise();
    temple::taskscheduler::initialise_task_scheduler();

    for (;;)
    {
        VM_START;

        auto response = temple::ui::bridge::read_ui();

        std::string script = "";
        std::string result;

        switch (response.protocol) {
        case temple::ui::bridge::pipe_protocol::script_execute:
        {
            script = response.data;
            result = temple::lua::execution::serialize_script(script);
            break;
        }
        case temple::ui::bridge::pipe_protocol::temple_store_execute:
        {
            auto t_script = temple::store::get_script(response.data);

            if (t_script.has_value())
            {
                //std::cout << *t_script << "\n";
                script = *t_script;
                result = temple::lua::execution::serialize_script_nodebug(script);
            }
            else
            {
                temple::ui::bridge::write_pipe_int(0);
                continue;
            }
            break;
        }
        default:
            temple::ui::bridge::write_pipe_int(0);
            break;
        }

        if (!result[0])
        {
            temple::ui::bridge::write_pipe_string(std::string(&result[1]));

            continue;
        }
        else
            temple::ui::bridge::write_pipe_int(0);

        temple::taskscheduler::add_script(result);

        VM_END;;

    }
}

BOOL APIENTRY DllMain( HMODULE h_module, DWORD  ul_reason_for_call, LPVOID lp_reserved)
{
    switch (ul_reason_for_call)
    {
        case DLL_PROCESS_ATTACH:
        {
            DisableThreadLibraryCalls(h_module);
            sodium_init();

            if (GetModuleHandleA(xorstr("RobloxPlayerBeta.exe")))
            {
                std::thread{ start }.detach();
            }
            break;
        }
    }

    return true;
}

