#pragma once
#include <rbx/memory/memdata/memdata.h>

#include <cstdint>

namespace temple::checks::retcheck
{
	void arguments_push();

	template<class R, class...Args>
	R ret_call(std::uintptr_t func, Args...arg)
	{
		__asm
		{
			mov esi, esp
			mov edi, end
		}

		reinterpret_cast<void(__stdcall*)(Args...)>(&arguments_push)(arg...);

		__asm
		{
			push temple::memdata::memloc::ret_location
			jmp func
			end :
			mov esp, esi
		}

		if constexpr (!std::is_same_v<R, void>)
		{
			R result{};

			__asm mov result, eax

			return result;
		}
	}

	template<class R, class...Args>
	R ret_fastcall(std::uintptr_t func, Args...arg)
	{
		__asm
		{
			mov esi, esp
			mov edi, end
		}

		reinterpret_cast<void(__fastcall*)(Args...)>(&arguments_push)(arg...);

		__asm
		{
			push temple::memdata::memloc::ret_location
			jmp func
			end :
			mov esp, esi
		}

		if constexpr (!std::is_same_v<R, void>)
		{
			R result{};

			__asm mov result, eax

			return result;
		}
	}
}