#include "trustcheck.h"

#include <rbx/memory/memdata/memdata.h>
#include "../minhook/MinHook.h"

#include <Windows.h>
#include <intrin.h>
#include <iostream>

namespace temple::checks::trustcheck
{
	using getmodulefilename_fn = DWORD(WINAPI*)(HMODULE, LPSTR, DWORD);

	getmodulefilename_fn getmodulefilename_cb = nullptr;

	void __stdcall fix_url(std::string* url)
	{
		if (url->find("mshtml.dll?") != std::string::npos)
			*url = url->substr(std::strlen("mshtml.dll?"));
	}

	__declspec(naked)
	DWORD __stdcall getmodulefilename_detour(HMODULE hmodule, LPSTR lpfilename, DWORD nsize)
	{
		__asm
		{
			mov eax, [esp]
			cmp eax, memdata::memloc::trustcheck_return
			jne original

			add esp, 16
			pop edi
			pop esi

			pushad

			push esi
			call fix_url

			popad

			mov ecx, [ebp - 8]
			mov fs : 0, ecx

			pop ebx
			mov esp, ebp
			pop ebp
			mov al, 1
			ret

			original:
			jmp getmodulefilename_cb
		}
	}

	bool tchooked = false;

	bool hook_getmodulefilename()
	{
		if (tchooked == false)
		{
			if (MH_CreateHook(&GetModuleFileNameA, &getmodulefilename_detour,
				reinterpret_cast<LPVOID*>(&getmodulefilename_cb)) != MH_OK)
				return false;

			if (MH_EnableHook(&GetModuleFileNameA) != MH_OK)
				return false;
		}
		tchooked = true;

		return true;
	}
}