#pragma once
#include <rbx/structs/lua.h>

#include <cstdint>

namespace temple::customfn
{
	namespace initialiser
	{
		void load_crypto_functions(temple::lua::state);
		void load_temple_functions(temple::lua::state);
		void load_drawing_functions(temple::lua::state);
		void load_rbx_functions(temple::lua::state);
		void load_reflection_functions(temple::lua::state);
		void load_debug_functions(temple::lua::state);
		void load_rlua_functions(temple::lua::state);
		void load_bit_functions(temple::lua::state);
		void load_win_functions(temple::lua::state);
		void load_console_functions(temple::lua::state);
	}

	int getnamecallmethod(std::uintptr_t thread);
	int checkcaller(std::uintptr_t);

	void set_global_function(temple::lua::state, int(__cdecl*)(std::uintptr_t), const char*);
	void set_table_function(temple::lua::state, int(__cdecl*)(std::uintptr_t), const char*, const char*);
	void set_subtable_function(temple::lua::state, int(__cdecl*)(std::uintptr_t), const char*, const char*, const char*);

	lua::tvalue* get_argument(temple::lua::state, int, int, bool = true, bool = true, bool = true);
	void load_custom_functions(temple::lua::state);
}