#include "customfn.h"

#include <themida/ThemidaSDK.h>
#include <rbx/memory/functions/functions.h>
#include <rbx/memory/memdata/memdata.h>
#include <xorstr.h>

namespace temple::customfn
{
	using namespace memdata::lua::types;

	int setfpscap(std::uintptr_t thread)
	{
		auto arg1 = get_argument(thread, 1, memdata::lua::types::lua_tnumber);

		auto task_scheduler = *reinterpret_cast<std::uintptr_t*>(memdata::vars::rbx::task_scheduler);

		auto n = functions::lua::tonumber(thread, 1);

		*reinterpret_cast<double*>(task_scheduler + memdata::offsets::task_scheduler::frame_delay) =
			n <= 0 ? (1 / 10000) : (1 / n);

		return 0;
	}

	int setfflag(std::uintptr_t thread)
	{
		// guess I'll just use the same hack as setnamecallmethod
		auto arg1 = get_argument(thread, 1, lua_tstring);
		auto arg2 = get_argument(thread, 2, lua_tstring);

		auto flag = functions::lua::tostring(thread, 1);
		auto value = functions::lua::tostring(thread, 2);

		functions::fflag::set_fflag(flag, value);
		return 0;
	}

	namespace initialiser
	{
		void load_rbx_functions(temple::lua::state thread)
		{
			set_global_function(thread, setfpscap, xorstr("setfpscap"));
			set_global_function(thread, setfflag, xorstr("setfflag"));
		}
	}
}