#include "memdata.h"

#include <rbx/structs/instance.h>
#include <themida/ThemidaSDK.h>

#include <Windows.h>

namespace temple::memdata
{
	std::uintptr_t base = 0;

	namespace classes
	{
		std::uintptr_t game_pointer = 0x3A356BC;
		std::uintptr_t gamebasicsettings_pointer = 0x3020808;

		std::uintptr_t game           = 0;
		std::uintptr_t gamebasicsettings = 0;
		rbx::instance* datamodel      = 0;
		rbx::instance* script_context = 0;

		namespace lua
		{
			temple::lua::state rstate{ 0 };
			temple::lua::state state{ 0 };
		}
	}

	namespace functions
	{
		namespace lua
		{
			func_data load{ 0x145FAB0, calling_convention::cc_rbxcall };
			func_data luaC_step{ 0x14B2E30, calling_convention::cc_fastcall };
			func_data altfrealloc{ 0x14F2640, calling_convention::cc_rbxcall };
			func_data altnewblock_func{ 0x14F2860, calling_convention::cc_fastcall };
			func_data newblock_func{ 0x14F2750, calling_convention::cc_fastcall };
			func_data sandboxthread{ 0x48E720, calling_convention::cc_rbxcall };
			func_data index2adr{ 0x145B910, calling_convention::cc_fastcall };
			func_data luaD_rawrunprotected{ 0x1462FA0, calling_convention::cc_rbxcall };
			func_data f_call{ 0x145D0D0, calling_convention::cc_cdecl };
			func_data luaD_seterrorobj{ 0x1463120, calling_convention::cc_rbxcall };
			func_data free_func{ 0x12C3310, calling_convention::cc_rbxcall }; //DEPRECATED: TO BE REMOVED
			func_data callerrfunc(0x1464D80, calling_convention::cc_cdecl);
			func_data luaG_runerrorL{ 0x1475490, calling_convention::cc_stdcall};
			func_data luaC_barrierf{ 0x14B31E0, calling_convention::cc_rbxcall };
			func_data luaC_barriert{ 0x14B3220, calling_convention::cc_rbxcall };
			func_data luaG_indexerror(0x1474F30, calling_convention::cc_fastcall); // remake this yourself btw
			func_data luaT_objtypename(0x14F24E0, calling_convention::cc_fastcall);
			func_data callTM{ 0x14EB9F0, calling_convention::cc_rbxcall };
			func_data callTMres{ 0x14EADB0, calling_convention::cc_rbxcall };
			func_data luaH_set(0x14ECB20, calling_convention::cc_rbxcall);
			func_data luaH_setnum{ 0x14EEA20, calling_convention::cc_rbxcall };
			func_data auxgetinfo{ 0x1474AB0, calling_convention::cc_rbxcall };
			func_data index{ 0x55B5B0, calling_convention::cc_cdecl };
			func_data namecall{ 0x55B200, calling_convention::cc_cdecl };
			func_data spawn{ 0, calling_convention::cc_cdecl };
			func_data require{ 0, calling_convention::cc_cdecl }; 
		}
		namespace reflection
		{
			func_data instancebridge_push{ 0x552410, calling_convention::cc_cdecl };
		}

		namespace fflag
		{
			func_data set_fflag{ 0x1528E20, calling_convention::cc_thiscall };
		}

		namespace instance
		{
			func_data getnetworkowner(0x481160, calling_convention::cc_thiscall);

			func_data fireclickdetector{ 0xABFBF0, calling_convention::cc_thiscall };
			func_data fireproximityprompt{ 0xBCC600, calling_convention::cc_thiscall };

			func_data get_property_descriptor{ 0x55E5E0, calling_convention::cc_thiscall };

			func_data get_instance_property{ 0x554570, calling_convention::cc_rbxcall };
			func_data set_instance_property{ 0x559510, calling_convention::cc_rbxcall };
		}
	}

	namespace lua::types
	{
		std::int32_t lua_tnone = -1,
			lua_tnil = 0,
			lua_tboolean = 1,
			lua_tvector = 4,
			lua_tlightuserdata = 2,
			lua_tnumber = 3,
			lua_tstring = 5,
			lua_tuserdata = 9,
			lua_tfunction = 6,
			lua_tthread = 8,
			lua_ttable = 7,
			lua_tupval = 11; // mostly static (maybe)
	}

	namespace vars
	{
		namespace lua
		{
			std::uintptr_t xor_constant = 0x37872C0;
			std::uintptr_t nilobject = 0x220AB68;
			std::uintptr_t dummynode = 0x220B190;
			std::uintptr_t realloc_table = 0x359EB60;
			std::uintptr_t reallocation_alt = 0x2A91746;
		}

		namespace instance
		{
			std::uintptr_t property_table = 0x3742A38;
		}

		namespace rbx
		{
			std::uintptr_t task_scheduler = 0x3A365C8;
		}
	}

	namespace offsets
	{
		namespace lua
		{
			namespace state
			{
				std::ptrdiff_t state = 324;

				obfuscation_type state_obf = obfuscation_type::exor;

				std::ptrdiff_t status = 3;
				std::ptrdiff_t prealloc_mark = 5;
				std::ptrdiff_t nccalls = 48;
				std::ptrdiff_t baseccalls = 50;

				std::ptrdiff_t top  = 16;
				std::ptrdiff_t base = 20;
				std::ptrdiff_t g_env = 56;

				std::ptrdiff_t namecall   = 68;
				std::ptrdiff_t extraspace = 72;
 
				std::ptrdiff_t stack = 8;
				std::ptrdiff_t stacksize = 40;
				obfuscation_type stacksize_obf = obfuscation_type::inverse_sub;

				std::ptrdiff_t stack_last = 12;

				std::ptrdiff_t ci = 28;
				std::ptrdiff_t base_ci = 36;
				std::ptrdiff_t end_ci = 32;
				std::ptrdiff_t size_ci = 44;

				std::ptrdiff_t category = 4;

				std::ptrdiff_t openupval = 60;
				std::ptrdiff_t lcni = 52;

				std::ptrdiff_t gclist = 64;

				std::ptrdiff_t unk_0 = g_env;
				std::ptrdiff_t unk_1 = 6;


				namespace callinfo
				{
					std::ptrdiff_t base = 4;
					std::ptrdiff_t top = 12;
					std::ptrdiff_t func = 0;
				}

				namespace l_g
				{
					std::ptrdiff_t l_g = 24;
					obfuscation_type l_g_obf = obfuscation_type::inverse_sub;

					std::ptrdiff_t strt_hash = 0;
					std::ptrdiff_t nuse = 4;
					std::ptrdiff_t strt_size = 8;

					std::ptrdiff_t grayagain = 28;
					std::ptrdiff_t currentwhite = 20;
					std::ptrdiff_t totalbytes = 40;
					std::ptrdiff_t gcthreshold = 48;
					std::ptrdiff_t gcstate = 21;
					std::ptrdiff_t alloc_category = 324;
					std::ptrdiff_t altrealloc_link = 316;

					std::ptrdiff_t newthread_fn = 2140;
					std::ptrdiff_t newstring_fn = 2144;
					std::ptrdiff_t pcall_fn = 2160;

					std::ptrdiff_t rootgc = 36; // REMOVED

					std::ptrdiff_t frealloc = 12;
					std::ptrdiff_t ud = 16;

					std::ptrdiff_t metatable = 1420;

					std::ptrdiff_t tmname = 1460;
					obfuscation_type tmname_obf = obfuscation_type::inverse_sub;

					std::ptrdiff_t index_tm = 4;
					std::ptrdiff_t newindex_tm = 2;

					std::ptrdiff_t tmname_index = tmname + (4 * index_tm);
					std::ptrdiff_t tmname_newindex = tmname + (4 * newindex_tm);
					
					//std::ptrdiff_t tmname_key = 1416;
					//obfuscation_type tmname_key_obf = obfuscation_type::sub;

					//std::ptrdiff_t tmname_table = 1272;
					//obfuscation_type tmname_table_obf = obfuscation_type::sub;
				}

			}

			namespace upvalue
			{
				std::ptrdiff_t v = 4;
				std::ptrdiff_t u_value = 12;
				std::ptrdiff_t next = 12;
				std::ptrdiff_t prev = 8;
				std::ptrdiff_t n_next = 20;
				std::ptrdiff_t n_prev = 16;
			}

			namespace gcobj
			{
				std::ptrdiff_t next = 8; // mostly static
				std::ptrdiff_t marked = 1;
				std::ptrdiff_t tt = 0;
				std::ptrdiff_t category = 2;

				namespace entry
				{
					std::ptrdiff_t size = 40;

					std::ptrdiff_t next_gcobj = 12;
				}
			}

			namespace closure
			{
				std::ptrdiff_t isc = 3; // mostly static
				std::ptrdiff_t nups = 4; // mostly static (amaybe)
				std::ptrdiff_t maxstacksize = 5;
				std::ptrdiff_t env = 12; // mostly static (maybe)
				std::ptrdiff_t source = 16; // mostly static

				std::ptrdiff_t l_ups = 24;
				std::ptrdiff_t c_ups = 32;

				std::ptrdiff_t name = 24;
				std::ptrdiff_t continuation = 20;

				obfuscation_type source_obf = obfuscation_type::sub;
				obfuscation_type continuation_obf = obfuscation_type::inverse_sub;
				obfuscation_type name_obf = obfuscation_type::add;
			}

			namespace proto
			{
				std::ptrdiff_t maxstacksize = 82;
				std::ptrdiff_t nups = 81;

				std::ptrdiff_t sizep = 52;
				std::ptrdiff_t sizek = 56;
				std::ptrdiff_t sizecode = 60;

				std::ptrdiff_t k = 16;
				std::ptrdiff_t p = 28;
				std::ptrdiff_t code = 8;

				std::ptrdiff_t source = 4;

				std::ptrdiff_t name = 36;
				obfuscation_type name_obf = obfuscation_type::exor;

				obfuscation_type proto_obf = obfuscation_type::inverse_sub;
				obfuscation_type source_obf = proto_obf;
			}

			namespace table
			{
				std::ptrdiff_t readonly = 3;
				std::ptrdiff_t flags = 5;
				std::ptrdiff_t lsizenode = 4;
				std::ptrdiff_t lastfree = 12;
				std::ptrdiff_t nodesize = 7;
				std::ptrdiff_t sizearray = 8;
				std::ptrdiff_t gclist = 24;

				std::ptrdiff_t node = 28;
				obfuscation_type node_obf = obfuscation_type::sub;

				std::ptrdiff_t t_array = 16;
				obfuscation_type t_array_obf = obfuscation_type::sub;

				std::ptrdiff_t metatable = 20;
				obfuscation_type metatable_obf = obfuscation_type::sub;
			}

			namespace node
			{
				std::ptrdiff_t i_key = 28;
				std::ptrdiff_t value = 16;
				std::ptrdiff_t gval = 12;
			}

			namespace userdata
			{
				std::ptrdiff_t size = 4;
				std::ptrdiff_t tag = 3;
				std::ptrdiff_t ud = 16;

				std::ptrdiff_t metatable = 8;
				obfuscation_type metatable_obf = obfuscation_type::sub;
			}

			namespace string
			{
				std::ptrdiff_t raw = 20; // mostly static

				std::ptrdiff_t str_id = 4;

				std::ptrdiff_t tsv_len = 16;
				obfuscation_type tsv_len_obf = obfuscation_type::sub;

				std::ptrdiff_t hash = 12;
				obfuscation_type hash_obf = obfuscation_type::exor;
			}
		}

		namespace weakthreadref
		{
			std::ptrdiff_t thread_node = 352;	
			std::ptrdiff_t node_first = 4;
			std::ptrdiff_t node_next = 12;
			std::ptrdiff_t state_off1 = 16;
			std::ptrdiff_t state_off2 = 4;
		}

		namespace instance
		{
			std::ptrdiff_t start_of_children = 44;
			std::ptrdiff_t name = 40;

			namespace property_descriptor
			{
				std::ptrdiff_t scriptable = 32;
			}

			namespace event_instance
			{
				std::ptrdiff_t source = 12;
				std::ptrdiff_t first_node = 56;
			}

			namespace signal_connection
			{
				std::ptrdiff_t next = 16;
			}

			namespace localscript
			{
				std::ptrdiff_t protected_string = 380;
			}

			namespace modulescript
			{
				std::ptrdiff_t protected_string = 360;
			}
		}

		namespace task_scheduler
		{
			std::ptrdiff_t frame_delay = 280;
		}

		namespace game
		{
			std::ptrdiff_t is_loaded = 844;
			std::ptrdiff_t non_networked = 1448;
		}
	}

	namespace memloc
	{
		std::uintptr_t ret_location = 0x7004B;
		std::uintptr_t createevent_trigger = 0x25D66D;
		std::uintptr_t trustcheck_return = 0x16917FC;
	}

	void base_addresses()
	{
		base = reinterpret_cast<std::uintptr_t>(GetModuleHandleA(nullptr));

		/* Classes */

		classes::game_pointer += base;
		classes::gamebasicsettings_pointer += base;

		VM_START;

		/* Lua Functions */

		functions::lua::load.ptr          += base;
		functions::lua::spawn.ptr         += base;
		functions::lua::index2adr.ptr     += base;
		functions::lua::luaC_step.ptr += base;
		functions::lua::sandboxthread.ptr += base;
		functions::lua::f_call.ptr += base;
		functions::lua::callerrfunc.ptr += base;
		functions::lua::luaG_runerrorL.ptr  += base;
		functions::lua::luaC_barrierf.ptr  += base;
		functions::lua::luaC_barriert.ptr += base;
		functions::lua::luaH_set.ptr += base;
		functions::lua::luaH_setnum.ptr       += base;
		functions::lua::luaG_indexerror.ptr += base;
		functions::lua::luaT_objtypename.ptr += base;
		functions::lua::auxgetinfo.ptr       += base;
		functions::lua::altfrealloc.ptr += base;
		functions::lua::newblock_func.ptr   += base;
		functions::lua::altnewblock_func.ptr += base;
		functions::lua::free_func.ptr += base;
		functions::lua::luaD_seterrorobj.ptr += base;
		functions::lua::luaD_rawrunprotected.ptr += base;
		functions::lua::callTMres.ptr += base;
		functions::lua::callTM.ptr += base;
		functions::lua::index.ptr += base;
		functions::lua::namecall.ptr += base;

		/* Reflection Functions */

		functions::reflection::instancebridge_push.ptr += base;

		functions::fflag::set_fflag.ptr += base;

		/* Instance Functions */

		functions::instance::getnetworkowner.ptr += base;

		functions::instance::fireclickdetector.ptr       += base;
		functions::instance::fireproximityprompt.ptr += base;
		functions::instance::get_property_descriptor.ptr += base;

		functions::instance::get_instance_property.ptr += base;
		functions::instance::set_instance_property.ptr += base;

		/* Memory Locations */

		memloc::ret_location        += base;
		memloc::createevent_trigger += base;
		memloc::trustcheck_return   += base;

		/* Variables */

		vars::instance::property_table += base;
		vars::lua::xor_constant        += base;
		vars::lua::nilobject		   += base;
		vars::lua::dummynode           += base;
		vars::lua::realloc_table	   += base;
		vars::lua::reallocation_alt	   += base;

		vars::rbx::task_scheduler	   += base;

		VM_END;;
	}
}


