#pragma once

#include <rbx/structs/lua.h>

#include <unordered_set>
#include <cstdint>
#include <vector>

namespace temple::memory
{
	namespace ptr_obf
	{
		enum class obfuscation_type
		{
			exor,
			add,
			sub,
			inverse_sub
		};

		std::uintptr_t deobf(std::uintptr_t, obfuscation_type);
		void obf(std::uintptr_t, std::uintptr_t, obfuscation_type);
	}

	extern std::unordered_set<std::uintptr_t> temple_environments;

	std::uintptr_t get_game();
	void validate_memory_locations(std::vector<std::ptrdiff_t>);
	void prepare_memory();
	bool check_teleport();
}