#include "taskscheduler.h"

#include <rbx/lua/customfn/mthooks/mthooks.h>
#include <rbx/memory/functions/functions.h>
#include <rbx/memory/memdata/memdata.h>
#include <rbx/checks/minhook/MinHook.h>
#include <rbx/checks/peblink/peblink.h>
#include <rbx/lua/customfn/customfn.h>
#include <rbx/checks/checks.h>
#include <themida/ThemidaSDK.h>
#include <rbx/lua/execution.h>
#include <overlay/overlay.h>
#include <util/bitwise.h>
#include <http/http.h>
#include <yara/yara.h>
#include <xorstr.h>

#include <intrin.h>
#include <deque>

#include <iostream>
#include <mutex>

#include <temple/config/config.h>
#include <util/util.h>

namespace temple::taskscheduler
{
	std::deque<std::string> teleport_queue;
	std::deque<std::string> script_queue;
	std::decay_t<decltype(GetCurrentThreadId)> o_get_current_thread_id;
	std::string autoexec = "";
	std::once_flag step_flag;
	void step();

	DWORD __stdcall get_current_thread_id_detour()
	{
		if (*static_cast<std::uint32_t*>(_ReturnAddress()) == 0x81390F8B)
		//if(reinterpret_cast<std::uintptr_t>(_ReturnAddress()) - memdata::base == 0x24DFEA)
		{
			try
			{
				step();
			}
			catch (...)
			{

			}
		}

		return o_get_current_thread_id();
	}

	bool initialised = false;
	bool on_start_yara = false;

	void step()
	{
		if (!memory::get_game() || (memory::get_game() && !functions::game::is_loaded(memory::get_game()) && initialised == false))
		{
			//std::cout << "sup\n";
			if (!on_start_yara)
			{
				std::thread(temple::yara::yara_process_task).detach();
				on_start_yara = true;
			}
		}

		std::call_once(step_flag, []() {

			temple::yara::check_yara_process();
			//std::cout << " - Preparing memory...\n\n";
			temple::memory::prepare_memory();

			//std::cout << " -- Base: " << std::hex << temple::memdata::base << "\n";
			//std::cout << " -- DataModel: " << std::hex << temple::memdata::classes::datamodel << "\n";
			//std::cout << " -- Script Context: " << std::hex << temple::memdata::classes::script_context << "\n";
			//std::cout << " -- Lua State: " << std::hex << temple::memdata::classes::lua::state << "\n";

			//std::cout << "\n";

			//std::cout << " - Bypassing checks...";

			if (!temple::checks::bypass_checks())
			{
				//std::cout << "FAILED!\n\n";
				MessageBoxA(NULL, xorstr("Failed to initialise Temple!"), xorstr(":("), MB_OK);
				exit(0);
				return 0;
			}

			//std::cout << " - Preparing overlay...";


			if (temple::overlay::initialise_overlay())
			{
				//std::cout << " OK!\n\n";
			}
			else
			{
				//std::cout << " FAILED!\n\n";
			}

			

			//std::cout << "dll: " << GetModuleHandleA("temple.dll") << "\n";

			auto temple_base = GetModuleHandleA(xorstr("temple.dll"));

			temple::checks::peblink::unlink(temple_base);

			DWORD OldProtect = 0;

			SYSTEM_INFO systemInfo;
			GetSystemInfo(&systemInfo);

			// Change memory protection
			if(temple_base)
			VirtualProtect(temple_base, systemInfo.dwPageSize,
				PAGE_READWRITE, &OldProtect);

			// Erase the header
			if (temple_base)
			SecureZeroMemory(temple_base, sizeof(IMAGE_DOS_HEADER) + sizeof(IMAGE_NT_HEADERS));

			//std::cout << " - Loading custom functions...";

		    temple::customfn::load_custom_functions(temple::memdata::classes::lua::state);
			
			//std::cout << "OK\n\n";

			temple::lua::execution::run_autoexec(temple::memdata::classes::lua::state);
			temple::customfn::mthooks::prepare_hooks(temple::memdata::classes::lua::state);
			
			//temple::lua::execution::load_script(temple::memdata::classes::lua::state, *temple::util::file::read_file(temple::config::util::current_path + "\\workspace\\magicautoexec.lua"));
			//temple::functions::lua::spawn(temple::memdata::classes::lua::state);
			//std::cout << "OK\n\n";

			//std::cout << " - Autoexecuting...\n\n";

			temple::lua::execution::autoexecute(temple::memdata::classes::lua::state);


			//functions::lua::getfield(memdata::classes::lua::state, -10002, "xpcall");
			//std::uintptr_t func = functions::lua::closure::get_source(functions::lua::index2adr(memdata::classes::lua::state, -1)->v.gcobj);
			////std::cout << std::hex << func - memdata::base + 0x400000 << "\n";
			/*
			functions::lua::getfield(memdata::classes::lua::state, -10002, "game");
			functions::lua::getfield(memdata::classes::lua::state, -1, "Players");
			functions::lua::getfield(memdata::classes::lua::state, -1, "PlayerAdded");

			auto event_instance = functions::lua::touserdata(memdata::classes::lua::state, -1);

			//std::cout << "penis might be: " << *reinterpret_cast<std::uintptr_t*>(event_instance) << "\n";

			if (!event_instance)
			{
				//std::cout << "event_instance is null\n";
			}

			auto pre_pre_func = *reinterpret_cast<std::uintptr_t*>(event_instance);

			if (!pre_pre_func)
			{
				//std::cout << "pre_pre_func is null\n";
			}

			auto pre_func = *reinterpret_cast<std::uintptr_t*>(pre_pre_func);

			if (!pre_func)
			{
				//std::cout << "pre_func is null\n";
			}

			auto func = *reinterpret_cast<std::uintptr_t*>(pre_func + 4);

			if (!func)
			{
				//std::cout << "func is null\n";
			}

			//std::cout << std::hex << "normal func " << func << "\n";
			//std::cout << std::hex << "winbase func " << func - memdata::base + 0x400000 << "\n";*/

			//std::cout << "Ready for execution!\n";
			initialised = true;
			});

		////std::cout << std::hex << memdata::classes::game << "\n";
		////std::cout << std::hex << *reinterpret_cast<std::uintptr_t*>(memdata::classes::game_pointer) << "\n";
		//system("cls");
		//throw std::exception("tset");

		if (memory::check_teleport())
		{
			std::thread(temple::yara::yara_process_task).detach();

			VM_START;
			temple::customfn::load_custom_functions(temple::memdata::classes::lua::state);

			temple::lua::execution::load_script(temple::memdata::classes::lua::state, autoexec);
			temple::functions::lua::spawn(temple::memdata::classes::lua::state);
			functions::lua::settop(temple::memdata::classes::lua::state, 0);
			VM_END;;

			temple::lua::execution::run_autoexec(temple::memdata::classes::lua::state);
			temple::customfn::mthooks::prepare_hooks(temple::memdata::classes::lua::state);

			temple::lua::execution::autoexecute(temple::memdata::classes::lua::state);

			script_queue.clear();

			while (!teleport_queue.empty())
			{
				//std::cout << "executed\n";
				temple::lua::execution::execute_bytecode(temple::memdata::classes::lua::state, teleport_queue.front());
				teleport_queue.pop_front();
			}
		}



		while (!script_queue.empty())
		{
			//std::cout << "executed\n";
			temple::lua::execution::execute_bytecode(temple::memdata::classes::lua::state, script_queue.front());
			script_queue.pop_front();
		}
	}

	void add_teleport_script(std::string s)
	{
		teleport_queue.push_back(s);
	}

	void add_script(std::string s)
	{
		script_queue.push_back(std::move(s));
	}

	using waitingscripts_hooktmp = int(__thiscall*)(std::uintptr_t, int);
	waitingscripts_hooktmp waitingscripts_hookcb = nullptr;

	int __fastcall waitingscripts_hook(std::uintptr_t a1, int edx, int a2)
	{
		step();

		return waitingscripts_hookcb(a1, a2);
	}

	bool initialise_task_scheduler()
	{
		
		
		if (MH_CreateHook(&GetCurrentThreadId, &get_current_thread_id_detour,
				reinterpret_cast<LPVOID*>(&o_get_current_thread_id)) != MH_OK)
			return false;

		if (MH_EnableHook(&GetCurrentThreadId) != MH_OK)
			return false;
			
		/*
		struct job
		{
			std::uintptr_t vftable;
			std::uint32_t padding[3];
			std::string name;
		};

		auto task_scheduler = *reinterpret_cast<std::uintptr_t*>(memdata::vars::rbx::task_scheduler);
		auto jobs = *reinterpret_cast<std::vector<std::shared_ptr<job>>*>(task_scheduler + 300);

		for (std::size_t i = 0; i < jobs.size(); i++)
		{
			auto job = jobs[i];
			//std::cout << "Job name: " << job->name << " " << std::hex << "VFTable: " << job->vftable << "\n";

			if (job->name == "WaitingHybridScriptsJob")
			{
				//std::cout << "Found job!\n";

				std::uintptr_t* new_vft = new std::uintptr_t[6];

				memcpy(new_vft, reinterpret_cast<void*>(job->vftable), 6 * sizeof(std::uintptr_t));

				waitingscripts_hookcb = reinterpret_cast<waitingscripts_hooktmp>(new_vft[2]);
				new_vft[2] = reinterpret_cast<std::uintptr_t>(&waitingscripts_hook);

				job->vftable = reinterpret_cast<std::uintptr_t>(new_vft);

				//std::cout << "DONE!\n";
			}
		}*/

		return true;
	}
}