#include "bridge.h"
#include <xorstr.h>

#include <Windows.h>
#include <cstddef>
#include <thread>
#include <chrono>

#include <iostream>

namespace temple::ui::bridge
{

    auto pipe_name = "\\\\.\\pipe\\HentaiGirlsBest";

    HANDLE ui_pipe = INVALID_HANDLE_VALUE;
    bool   pipeinit = false;

    bool read_pipe(void* data, std::size_t size, unsigned long& bytes_read)
    {
        return ReadFile(ui_pipe, data, size, &bytes_read, NULL);
    }

    bool write_pipe(void* data, std::size_t size, unsigned long& bytes_writted)
    {
        return WriteFile(ui_pipe, data, size, &bytes_writted, NULL);
    }

    void disconnect_pipe()
    {
        DisconnectNamedPipe(ui_pipe);
    }

    bool initialise_pipe()
    {
        ui_pipe = CreateNamedPipeA(pipe_name,
            PIPE_ACCESS_DUPLEX,
            PIPE_TYPE_MESSAGE |
            PIPE_READMODE_MESSAGE |
            PIPE_NOWAIT,                    //changed from nowait
            PIPE_UNLIMITED_INSTANCES,    // max. instances 
            0xFFFFFFFF,                    // output buffer size 
            0xFFFFFFFF,                    // input buffer size 
            5000,                // client time-out 
            NULL);

        if (ui_pipe == INVALID_HANDLE_VALUE)
            return false;

        return true;
    }

    pipe_response read_ui()
    {
        while (true)
        {
            std::uint32_t message = 0;
            unsigned long bytes_read = 0;

            if (!read_pipe(&message, sizeof(message), bytes_read) || bytes_read == 0)
            {
                if (GetLastError() == ERROR_BROKEN_PIPE)
                {
                    disconnect_pipe();

                    initialise_pipe();

                    continue;
                }
                else
                {
                    continue;
                }
            }

            if (message)
            {
                char* data = new char[message];

                while (!read_pipe(data, message, bytes_read) || bytes_read == 0)
                    continue;


                auto str = pipe_response{ static_cast<pipe_protocol>(data[0]), std::string(data + 1, message - 1) };

                delete[] data;

                return str;
            }

            std::this_thread::sleep_for(std::chrono::milliseconds(10));
        }
        return { pipe_protocol::empty, "" };
    }

    std::string read_string()
    {

        while (true) {
            std::uint32_t message = 0;
            unsigned long bytes_read = 0;

            if (!read_pipe(&message, sizeof(message), bytes_read) || bytes_read == 0)
            {
                if (GetLastError() == ERROR_BROKEN_PIPE)
                {
                    disconnect_pipe();

                    initialise_pipe();
                }
                else
                {
                    continue;
                }
            }

            if (message)
            {
                char* data = new char[message];

                while (!read_pipe(data, message, bytes_read) || bytes_read == 0)
                    continue;

                auto str = std::string(data, message);

                delete[] data;

                return str;
            }

            std::this_thread::sleep_for(std::chrono::milliseconds(10));
        }
        return "";
    }

    std::string read_unicode_string()
    {

        while (true) {
            std::uint32_t message = 0;
            unsigned long bytes_read = 0;

            if (!read_pipe(&message, sizeof(message), bytes_read) || bytes_read == 0)
            {
                if (GetLastError() == ERROR_BROKEN_PIPE)
                {
                    ////std::cout << "lez go\n";
                    disconnect_pipe();

                    initialise_pipe();
                }
                else
                {
                    continue;
                }
            }

            if (message)
            {
                wchar_t* data = new wchar_t[message];

                while (!read_pipe(data, message, bytes_read) || bytes_read == 0)
                    continue;

                const auto str = std::wstring_view{ data, message };

                delete[] data;

                return std::string(str.begin(), str.end());
            }

            std::this_thread::sleep_for(std::chrono::milliseconds(10));
        }
        return "";
    }


    void write_pipe_string(std::string str)
    {
        unsigned long bytes_written = 0;
        std::size_t strsize = str.length();

        if (!write_pipe(&strsize, sizeof(size_t), bytes_written) || bytes_written == 0)
            return;

        write_pipe(str.data(), strsize, bytes_written);

    }

    void write_pipe_int(std::uint32_t n)
    {
        unsigned long bytes_written = 0;

        write_pipe(&n, sizeof(std::uint32_t), bytes_written);
    }
}
