#pragma once
#include <string>
#include <cstdint>

namespace temple::ui::bridge
{
    enum class pipe_protocol : char {
        empty,
        script_execute = '1',
        temple_store_execute = '2'
    };

    struct pipe_response
    {
        pipe_protocol protocol;
        std::string data;
    };

    bool initialise_pipe();

    std::string read_string();

    pipe_response read_ui();

    void write_pipe_string(std::string str);
    void write_pipe_int(std::uint32_t n);
}
