#pragma once

#include <optional>
#include <string>
#include <vector>

namespace temple::util
{
	namespace file
	{
		std::optional<std::string> read_file(const std::string&);
		void write_file(const std::string&, const std::string&);
		void append_file(const std::string&, std::string);
		void create_directory(const std::string&);
		std::vector<std::string> get_files(const std::string&);
		std::vector<std::string> get_filenames(const std::string&);
		bool check_illegal_extension(std::string);
		void delete_file(const std::string&);
		bool is_folder(const std::string&);
		bool is_file(const std::string&);
	}

	namespace clipboard
	{
		void write_text(const std::string& txt);
	}

	namespace input
	{
		namespace mouse
		{
			void move(int, int, bool = false);
			void input(bool, bool);
			void scroll(int);
		}
		namespace keyboard
		{
			void input(int, bool);
		}
	}

	namespace string
	{
		std::string to_lower(std::string);
	}
}
