#include "elements.h"

#include <vector>

namespace temple::overlay::elements
{
	std::vector<base*> elements;

	uint32_t color3::to_hex()
	{
		return (this->a << 24) | (this->b << 16) | (this->g << 8) | (this->r);
	}

	element_type base::get_type()
	{
		return this->type;
	}

	void base::remove()
	{
		const auto& it = std::find(elements.begin(), elements.end(), this);

		if (it != elements.end())
			elements.erase(it);
	}

	void base::move(size_t position)
	{
		if ((position) > elements.size())
			position = elements.size();

		const auto& it = std::find(elements.begin(), elements.end(), this);

		if (it != elements.end())
			std::swap(*it, elements.back());
	}
}