#pragma once

#include <string>
#include <optional>
#include <vector>
#include <http/http.h>
#include <crypto/crypto.h>

namespace temple::auth
{
    struct auth_session
    {
        std::string session_id;

        crypto::pk_encryption server;
        crypto::pk_encryption client;
        crypto::pk_encryption swapped_server;
        crypto::pk_encryption swapped_client;

        crypto::signature signed_server;
        crypto::signature signed_client;

        auth_session();
    };

    std::vector<http::parameter> encrypt_parameters(std::vector<http::parameter> unsafe_parameters, const auth_session& session, bool dual_layered = false);
    bool key_exchange(auth_session& session);
    bool decrypt_response(std::string& result, auth_session& session, bool dual_layered = false);
    std::optional<std::string> registry_get_token();
    std::optional<std::string> registry_get_username();

    std::optional<std::vector<std::ptrdiff_t>> is_logged_in();
}
