#include "hwid_gen.h"

#include <crypto/crypto.h>
#include <xorstr.h>

#include <windows.h>
#include <Iphlpapi.h>
#include <comdef.h>
#include <Wbemidl.h>
#include <iostream>
#pragma comment(lib, "wbemuuid.lib")
#pragma comment(lib, "iphlpapi.lib")

namespace temple::auth::hwid_gen
{
    std::string mobo_product = "";

    std::string get_first_hdd_serial_number()
    {
        HANDLE h = CreateFileA(xorstr("\\\\.\\PhysicalDrive0"), 0, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL);
        if (h == INVALID_HANDLE_VALUE) return {};

        std::unique_ptr<std::remove_pointer<HANDLE>::type, void(*)(HANDLE)> hDevice{ h, [](HANDLE handle) {CloseHandle(handle); } };

        STORAGE_PROPERTY_QUERY storagePropertyQuery{};
        storagePropertyQuery.PropertyId = StorageDeviceProperty;
        storagePropertyQuery.QueryType = PropertyStandardQuery;

        STORAGE_DESCRIPTOR_HEADER storageDescriptorHeader{};

        DWORD dwBytesReturned = 0;
        if (!DeviceIoControl(hDevice.get(), IOCTL_STORAGE_QUERY_PROPERTY, &storagePropertyQuery, sizeof(STORAGE_PROPERTY_QUERY),
            &storageDescriptorHeader, sizeof(STORAGE_DESCRIPTOR_HEADER), &dwBytesReturned, NULL))
            return {};

        const DWORD dwOutBufferSize = storageDescriptorHeader.Size;
        std::unique_ptr<BYTE[]> pOutBuffer{ new BYTE[dwOutBufferSize]{} };

        if (!DeviceIoControl(hDevice.get(), IOCTL_STORAGE_QUERY_PROPERTY, &storagePropertyQuery, sizeof(STORAGE_PROPERTY_QUERY),
            pOutBuffer.get(), dwOutBufferSize, &dwBytesReturned, NULL))
            return {};

        STORAGE_DEVICE_DESCRIPTOR* pDeviceDescriptor = reinterpret_cast<STORAGE_DEVICE_DESCRIPTOR*>(pOutBuffer.get());
        const DWORD dwSerialNumberOffset = pDeviceDescriptor->SerialNumberOffset;
        if (dwSerialNumberOffset == 0) return {};
        const char* serialNumber = reinterpret_cast<const char*>(pOutBuffer.get() + dwSerialNumberOffset);
        return serialNumber;
    }

    std::string get_mac() {
        PIP_ADAPTER_INFO AdapterInfo;
        DWORD dwBufLen = sizeof(IP_ADAPTER_INFO);
        char* mac_addr = reinterpret_cast<char*>(malloc(18));

        AdapterInfo = reinterpret_cast<IP_ADAPTER_INFO*>(malloc(sizeof(IP_ADAPTER_INFO)));
        if (AdapterInfo == NULL) {
            free(mac_addr);
            return xorstr("badmac");
        }

        if (GetAdaptersInfo(AdapterInfo, &dwBufLen) == ERROR_BUFFER_OVERFLOW) {
            free(AdapterInfo);
            AdapterInfo = reinterpret_cast<IP_ADAPTER_INFO*>(malloc(dwBufLen));
            if (AdapterInfo == NULL) {
                free(mac_addr);
                return xorstr("badmac");
            }
        }
        std::string str = "";

        if (GetAdaptersInfo(AdapterInfo, &dwBufLen) == NO_ERROR) {

            PIP_ADAPTER_INFO pAdapterInfo = AdapterInfo;
            do {

                str += pAdapterInfo->Address[0];
                str += pAdapterInfo->Address[1];
                str += pAdapterInfo->Address[2];
                str += pAdapterInfo->Address[3];
                str += pAdapterInfo->Address[4];
                str += pAdapterInfo->Address[5];

                printf("\n");
                pAdapterInfo = pAdapterInfo->Next;
            } while (pAdapterInfo);
        }
        free(AdapterInfo);
        return str;
    }

    IEnumWbemClassObject* pEnumerator = NULL;
    IWbemServices* pSvc = NULL;
    IWbemLocator* pLoc = NULL;

    void init_wmi()
    {
        HRESULT hres;

        // Step 1: --------------------------------------------------
        // Initialize COM. ------------------------------------------

        if (GetModuleHandleA(xorstr("RobloxPlayerBeta.exe")))
            hres = CoInitializeEx(0, COINIT_MULTITHREADED);
        else
            hres = CoInitializeEx(0, COINIT_APARTMENTTHREADED);
        if (FAILED(hres))
        {
            return;                  // Program has failed.
        }

        // Step 2: --------------------------------------------------
        // Set general COM security levels --------------------------

       /* hres = CoInitializeSecurity(
            NULL,
            -1,                          // COM authentication
            NULL,                        // Authentication services
            NULL,                        // Reserved
            RPC_C_AUTHN_LEVEL_DEFAULT,   // Default authentication
            RPC_C_IMP_LEVEL_IMPERSONATE, // Default Impersonation
            NULL,                        // Authentication info
            EOAC_NONE,                   // Additional capabilities
            NULL                         // Reserved
        );


        if (FAILED(hres))
        {

            CoUninitialize();
            return "badwmi2";                    // Program has failed.
        }*/

        // Step 3: ---------------------------------------------------
        // Obtain the initial locator to WMI -------------------------

        hres = CoCreateInstance(
            CLSID_WbemLocator,
            0,
            CLSCTX_INPROC_SERVER,
            IID_IWbemLocator, (LPVOID*)&pLoc);

        if (FAILED(hres))
        {

            CoUninitialize();
            return ;                 // Program has failed.
        }

        // Step 4: -----------------------------------------------------
        // Connect to WMI through the IWbemLocator::ConnectServer method

    

        // Connect to the root\cimv2 namespace with
        // the current user and obtain pointer pSvc
        // to make IWbemServices calls.
        hres = pLoc->ConnectServer(
            _bstr_t(L"ROOT\\CIMV2"), // Object path of WMI namespace
            NULL,                    // User name. NULL = current user
            NULL,                    // User password. NULL = current
            0,                       // Locale. NULL indicates current
            NULL,                    // Security flags.
            0,                       // Authority (for example, Kerberos)
            0,                       // Context object 
            &pSvc                    // pointer to IWbemServices proxy
        );

        if (FAILED(hres))
        {

            pLoc->Release();
            CoUninitialize();
            return;                // Program has failed.
        }




        // Step 5: --------------------------------------------------
        // Set security levels on the proxy -------------------------

        hres = CoSetProxyBlanket(
            pSvc,                        // Indicates the proxy to set
            RPC_C_AUTHN_WINNT,           // RPC_C_AUTHN_xxx
            RPC_C_AUTHZ_NONE,            // RPC_C_AUTHZ_xxx
            NULL,                        // Server principal name 
            RPC_C_AUTHN_LEVEL_CALL,      // RPC_C_AUTHN_LEVEL_xxx 
            RPC_C_IMP_LEVEL_IMPERSONATE, // RPC_C_IMP_LEVEL_xxx
            NULL,                        // client identity
            EOAC_NONE                    // proxy capabilities 
        );

        if (FAILED(hres))
        {

            pSvc->Release();
            pLoc->Release();
            CoUninitialize();
            return;               // Program has failed.
        }

    }

    std::string get_wmi_data(const char* Loc, std::string DataType)
    {
        HRESULT hres = NULL;
        // Step 6: --------------------------------------------------
        // Use the IWbemServices pointer to make requests of WMI ----

        // For example, get the name of the operating system
        std::string query = xorstr("SELECT ") + DataType + xorstr(" FROM ");
        query += Loc;
        hres = pSvc->ExecQuery(
            bstr_t("WQL"),
            bstr_t(query.c_str()),
            WBEM_FLAG_FORWARD_ONLY | WBEM_FLAG_RETURN_IMMEDIATELY,
            NULL,
            &pEnumerator);

        if (FAILED(hres))
        {

            pSvc->Release();
            pLoc->Release();
            CoUninitialize();
            return xorstr("badwmi6");               // Program has failed.
        }

        // Step 7: -------------------------------------------------
        // Get the data from the query in step 6 -------------------

        IWbemClassObject* pclsObj = NULL;
        ULONG uReturn = 0;

        std::string result;

        while (pEnumerator)
        {
            HRESULT hr = pEnumerator->Next(WBEM_INFINITE, 1,
                &pclsObj, &uReturn);

            if (0 == uReturn)
            {
                break;
            }

            VARIANT vtProp;

            // Get the value of the Name property
            hr = pclsObj->Get(std::wstring(DataType.begin(), DataType.end()).c_str(), 0, &vtProp, 0, 0);
            std::wstring wideres(vtProp.bstrVal);
            result = std::string(wideres.begin(), wideres.end());

            VariantClear(&vtProp);

            pclsObj->Release();
        }

        // Cleanup
        // ========

        return result;
    }

    void uninit_wmi()
    {
        pSvc->Release();
        pLoc->Release();
        pEnumerator->Release();
        CoUninitialize();
    }

    std::string get_tiny_hwid()
    {
        std::string hdd_sn = get_first_hdd_serial_number();
        std::string mac_addr = get_mac();
        mac_addr = mac_addr.substr(0, mac_addr.length() / 2);

        std::string hwid = mobo_product + mac_addr + hdd_sn;

        hwid = crypto::sha512(hwid);

        hwid = crypto::bin2base64(hwid);

        return hwid;
    }

    std::string get_hwid()
    {
        std::string hdd_sn = get_first_hdd_serial_number();
        std::string mac_addr = get_mac();
        init_wmi();
        std::string proc_id = get_wmi_data(xorstr("Win32_Processor"), xorstr("ProcessorId"));
        std::string product = get_wmi_data(xorstr("Win32_BaseBoard"), xorstr("Product"));
        mobo_product = product;
        std::string mobo_sn = get_wmi_data(xorstr("Win32_BaseBoard"), xorstr("SerialNumber"));
        uninit_wmi();

        //std::cout << "HDDSn: " << hdd_sn << "\n";
        //std::cout << "macADDY: " << mac_addr << "\n";
        //std::cout << "procID: " << proc_id << "\n";
        //std::cout << "product: " << product << "\n";
        //std::cout << "serialnum: " << mobo_sn << "\n";

        std::string hwid = hdd_sn + mac_addr + proc_id + product + mobo_sn;

        hwid = crypto::sha512(hwid);

        hwid = crypto::bin2base64(hwid);

        //std::cout << hwid << "\n";

        return hwid;
    }
}