#pragma once
#include "luauinstruction/luainstruction.h"

extern "C"
{
#include <lua/lobject.h>
}

#include <unordered_map>
#include <vector>

namespace temple::transpiler
{
	class instruction_convertor
	{
	protected:
		bool is_debug = true;

		Proto* p;
		std::vector<Instruction> instruction_list;
		std::unordered_map<std::uint32_t, int> jump_table;
		std::vector<std::uint32_t> jump_list;
		std::vector<std::uint32_t> iequiv_list;
		std::vector<int> line_info;

		void push_instruction(luau::luau_instruction);
		std::uint8_t constant_to_stack(std::uint32_t, int);
		void add_jump_entry(int);
		void add_jump(int24_t);
		void offset_jumps();

	public:
		std::vector<Instruction> convert_instructions();
		std::vector<int> get_line_info();

		instruction_convertor(Proto* p) : p(p) {}
		instruction_convertor(Proto* p, bool is_debug) : p(p), is_debug(is_debug) {}
	};
}
