#pragma once
#include <cstdint>
#include "../int24_t/int24_t.h"

#pragma pack(push, 1)

namespace temple::transpiler
{
	namespace luau
	{
		union instruction
		{
			std::uint32_t iabc;
			struct
			{
				std::uint8_t i;
				union
				{
					struct
					{
						std::uint8_t a;
						union
						{
							struct
							{
								std::uint8_t b;
								std::uint8_t c;
							};
							std::uint16_t bx;
							std::int16_t sbx;
						};
					};
					int24_t sax;
				};
			};

			instruction() : iabc(0) {}
			instruction(std::uint32_t instr) : iabc(instr) {}
		};

		union pseudo_instruction
		{
			std::uint32_t abcd;
			struct
			{
				union
				{
					struct
					{
						std::uint8_t a;
						std::uint8_t b;
					};
					std::uint16_t ax;
				};
				std::uint8_t c;
				std::uint8_t d;
			};

			pseudo_instruction() : abcd(0) {}
			pseudo_instruction(std::uint32_t instr) : abcd(instr) {}
		};

		struct luau_instruction
		{
			bool has_pseudo = false;

			instruction instruction;
			pseudo_instruction pseudo;

			luau_instruction() : instruction(0) {}
			luau_instruction(std::uint32_t i) : instruction(i) {}
		};
	}
}

#pragma pack(pop)