#pragma once

namespace temple::transpiler
{
	enum class luau_opcodes
	{
		nop = 0x0,
		clearstackv = 0xA3,
		clearstacka = 0xC0,

		setglobal = 0x18,
		getglobal = 0x35,

		gettablek = 0x4D,
		gettabler = 0x87,
		settablek = 0x30,
		settabler = 0x6A,
		getupval = 0xFB,
		setupval = 0xDE,

		move = 0x52,
		loadnum = 0x8C,
		loadk = 0x6F,
		loadkx = 0x86,
		loadnil = 0xC6,
		loadbool = 0xA9,

		close = 0xC1,
		retn = 0x82,
		call = 0x9F,
		self = 0xBC,
		closure = 0xD9,
		vararg = 0xDD,

		jmp = 0x69,
		eq = 0x9A,
		neq = 0xF1,
		le = 0xB7,
		lt = 0xD4,
		be = 0x7D,
		bt = 0x60,
		test = 0x2B,
		ntest = 0xE,

		forprep = 0xA8,
		forloop = 0x8B,
		tforloop = 0x6E,

		mulk = 0x5B,
		mulr = 0x9,
		subk = 0x78,
		subr = 0x26,
		addk = 0x95,
		addr = 0x43,
		divk = 0x3E,
		divr = 0xEC,
		modk = 0x21,
		modr = 0xCF,
		powk = 0x4,
		powr = 0xB2,
		unm = 0x39,

		_not = 0x56,
		len = 0x1C,
		concat = 0x73,

		newtable = 0xFF,
		setlist = 0xC5,

		capture = 0x12

	};
}