#pragma once
#include "vectorstream/vectorstream.h"
#include <string>
#include <unordered_map>

extern "C"
{
#include <lua/lobject.h>
}

namespace temple::transpiler
{
	class serializer
	{
	protected:
		bool is_debug = true;

		std::unordered_map<Proto*, std::uint32_t> proto_map;

		std::size_t string_size = 0;
		std::size_t proto_size = 0;

		void write_proto_root(vstream& vs, vstream& vp, Proto* p);
		void write_proto_children(vstream& vs, vstream& vp, Proto* p);
		void write_proto(vstream& vs, Proto* p);

	public:
		std::string serialize(const std::string&);

		serializer() {}
		serializer(bool is_debug) : is_debug(is_debug) {}
	};
}