#pragma once
#include <cstdint>
#include <cstddef>
#include <string>
#include <vector>

namespace temple::transpiler
{
	class vstream
	{
	protected:
		std::vector<std::uint8_t> stream;

		void write_bytes(std::uint8_t*, std::size_t);
	public:
		void write_byte(std::uint8_t);
		void write_int(std::uint32_t);
		void write_double(double i);
		void write_compressed_int(std::uint32_t);
		void write_string(const char*, std::size_t);

		void add(vstream& vs);

		std::string to_string();
	};
}